% clear all;
close all;
clc;

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                                                           %%
%%                     RFID: Contrle d'accs  assistance vocale avec Arduino et Matlab                    %%
%% Lien: https://www.electronique-mixte.fr/rfid-controle-dacces-a-assistance-vocale-avec-matlab-et-arduino/ %%
%                                                                                                           %%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Open Serial Port

SerialCOM = Open(); % Open new port

%% Read audio file

% 
[Y_1, FS_1]=audioread('./Audio/EN_welcome_F.mp3');  % http://www.fromtexttospeech.com/
[Y_2, FS_2]=audioread('./Audio/EN_Wrong_F.mp3');
[Y_3, FS_3]=audioread('./Audio/Alarme_1.mp3');      % http://soundbible.com/1753-Alien-Siren.html
[Y_4, FS_4]=audioread('./Audio/EN_Last.mp3');

%% Read data from Serial port

while(1)
    % Read data
    DataArduino = fscanf(SerialCOM,'%d');
    switch DataArduino
        % Right code 
        case 130
            disp('Right code'); 
            sound(Y_1,FS_1);
            pause(1.1*length(Y_1)/FS_1);
        % Wrong code 
        case 140
            disp('Wrong code'); 
            sound(Y_2,FS_2);
            pause(1.1*length(Y_2)/FS_2);
        % Alarme
        case 150
            while(1)
                disp('Alarme!'); 
                sound(Y_3,FS_3);
                pause(1.1*length(Y_3)/FS_3);
            end
        % Last chance!     
        case 160
            disp('Last chance!'); 
            sound(Y_4,FS_4);
            pause(1.1*length(Y_4)/FS_4);
    end
    DataArduino=0;
end

%% Port Delete (Previous port if exist)

Delete(SerialCOM);
